

# ExecuteAction


Executes an action on a target resource.

## Request Syntax


```
POST /actions HTTP/1.1
Content-type: application/json

{
   "actionDefinitionId": "string",
   "actionPayload": { 
      "stringValue": "string"
   },
   "clientToken": "string",
   "resolveTo": { 
      "assetId": "string"
   },
   "targetResource": { 
      "assetId": "string",
      "computationModelId": "string"
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [actionDefinitionId](#API_ExecuteAction_RequestSyntax) **   <a name="iotsitewise-ExecuteAction-request-actionDefinitionId"></a>
The ID of the action definition.  
Type: String  
Length Constraints: Fixed length of 36.  
Pattern: `^(?!00000000-0000-0000-0000-000000000000)[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$`   
Required: Yes

 ** [actionPayload](#API_ExecuteAction_RequestSyntax) **   <a name="iotsitewise-ExecuteAction-request-actionPayload"></a>
The JSON payload of the action.  
Type: [ActionPayload](API_ActionPayload.md) object  
Required: Yes

 ** [clientToken](#API_ExecuteAction_RequestSyntax) **   <a name="iotsitewise-ExecuteAction-request-clientToken"></a>
A unique case-sensitive identifier that you can provide to ensure the idempotency of the request. Don't reuse this client token if a new idempotent request is required.  
Type: String  
Length Constraints: Minimum length of 36. Maximum length of 64.  
Pattern: `\S{36,64}`   
Required: No

 ** [resolveTo](#API_ExecuteAction_RequestSyntax) **   <a name="iotsitewise-ExecuteAction-request-resolveTo"></a>
The detailed resource this action resolves to.  
Type: [ResolveTo](API_ResolveTo.md) object  
Required: No

 ** [targetResource](#API_ExecuteAction_RequestSyntax) **   <a name="iotsitewise-ExecuteAction-request-targetResource"></a>
The resource the action will be taken on.  
Type: [TargetResource](API_TargetResource.md) object  
Required: Yes

## Response Syntax


```
HTTP/1.1 202
Content-type: application/json

{
   "actionId": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 202 response.

The following data is returned in JSON format by the service.

 ** [actionId](#API_ExecuteAction_ResponseSyntax) **   <a name="iotsitewise-ExecuteAction-response-actionId"></a>
The ID of the action.  
Type: String  
Length Constraints: Fixed length of 36.  
Pattern: `^(?!00000000-0000-0000-0000-000000000000)[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictingOperationException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceArn **   
The ARN of the resource that conflicts with this operation.  
 ** resourceId **   
The ID of the resource that conflicts with this operation.
HTTP Status Code: 409

 ** InternalFailureException **   
 AWS IoT SiteWise can't process your request right now. Try again later.  
HTTP Status Code: 500

 ** InvalidRequestException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters. Check your request and try again.  
HTTP Status Code: 400

 ** LimitExceededException **   
You've reached the quota for a resource. For example, this can occur if you're trying to associate more than the allowed number of child assets or attempting to create more than the allowed number of properties for an asset model.  
For more information, see [Quotas](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/quotas.html) in the * AWS IoT SiteWise User Guide*.  
HTTP Status Code: 410

 ** ResourceNotFoundException **   
The requested resource can't be found.  
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a rate limit. For example, you might have exceeded the number of AWS IoT SiteWise assets that can be created per second, the allowed number of messages per second, and so on.  
For more information, see [Quotas](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/quotas.html) in the * AWS IoT SiteWise User Guide*.  
HTTP Status Code: 429

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotsitewise-2019-12-02/ExecuteAction) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotsitewise-2019-12-02/ExecuteAction) 